#[doc = "Register `CFG21` reader"]
pub struct R(crate::R<CFG21_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<CFG21_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::convert::From<crate::R<CFG21_SPEC>> for R {
    fn from(reader: crate::R<CFG21_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `CFG21` writer"]
pub struct W(crate::W<CFG21_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<CFG21_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl core::convert::From<crate::W<CFG21_SPEC>> for W {
    fn from(writer: crate::W<CFG21_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `NC0` reader - Spare register bit"]
pub struct NC0_R(crate::FieldReader<bool, bool>);
impl NC0_R {
    pub(crate) fn new(bits: bool) -> Self {
        NC0_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for NC0_R {
    type Target = crate::FieldReader<bool, bool>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `NC0` writer - Spare register bit"]
pub struct NC0_W<'a> {
    w: &'a mut W,
}
impl<'a> NC0_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x01) | (value as u8 & 0x01);
        self.w
    }
}
#[doc = "Field `NC1` reader - Spare register bit"]
pub struct NC1_R(crate::FieldReader<bool, bool>);
impl NC1_R {
    pub(crate) fn new(bits: bool) -> Self {
        NC1_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for NC1_R {
    type Target = crate::FieldReader<bool, bool>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `NC1` writer - Spare register bit"]
pub struct NC1_W<'a> {
    w: &'a mut W,
}
impl<'a> NC1_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 1)) | ((value as u8 & 0x01) << 1);
        self.w
    }
}
impl R {
    #[doc = "Bit 0 - Spare register bit"]
    #[inline(always)]
    pub fn nc0(&self) -> NC0_R {
        NC0_R::new((self.bits & 0x01) != 0)
    }
    #[doc = "Bit 1 - Spare register bit"]
    #[inline(always)]
    pub fn nc1(&self) -> NC1_R {
        NC1_R::new(((self.bits >> 1) & 0x01) != 0)
    }
}
impl W {
    #[doc = "Bit 0 - Spare register bit"]
    #[inline(always)]
    pub fn nc0(&mut self) -> NC0_W {
        NC0_W { w: self }
    }
    #[doc = "Bit 1 - Spare register bit"]
    #[inline(always)]
    pub fn nc1(&mut self) -> NC1_W {
        NC1_W { w: self }
    }
    #[doc = "Writes raw bits to the register."]
    pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "Spare register bits\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [cfg21](index.html) module"]
pub struct CFG21_SPEC;
impl crate::RegisterSpec for CFG21_SPEC {
    type Ux = u8;
}
#[doc = "`read()` method returns [cfg21::R](R) reader structure"]
impl crate::Readable for CFG21_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [cfg21::W](W) writer structure"]
impl crate::Writable for CFG21_SPEC {
    type Writer = W;
}
#[doc = "`reset()` method sets CFG21 to value 0"]
impl crate::Resettable for CFG21_SPEC {
    #[inline(always)]
    fn reset_value() -> Self::Ux {
        0
    }
}
